let express = require('express')
let router = express.Router()

const Errors = require('../lib/errors')
let { User } = require('../models')

router.all('*', (req, res, next) => {
    if(req.session.loggedIn) {
        next()
    } else {
        res.status(200)
        res.json({
            errors: ["Please login to use this endpoint, idk what you expected"]
        })
    }
})
router.get('/', async (req, res, next) => {
    try {
        let queryObj = {
            attributes: {exclude: ['hash', 'currency2', 'emailToken']},
            where: {username: req.session.username}
        }
         let user = await User.findOne(queryObj)
         if(!user) throw Errors.accountDoesNotExist
         res.json(user.toJSON())

    } catch (err) { next(err) }
})

module.exports = router
