let bcrypt = require('bcryptjs')
let multer = require('multer')
let express = require('express')
let router = express.Router()
var Recaptcha = require('express-recaptcha').RecaptchaV3;
var recaptcha = new Recaptcha('6LdlbrwZAAAAAKvtcVQhVl_QaNOqmQ4PgyW3SKHy', '6LdlbrwZAAAAAMAWPVDrL8eNPxrws6AMDtLf1bgd');
var reCAPTCHASecret = "6LdlbrwZAAAAAKvtcVQhVl_QaNOqmQ4PgyW3SKHy";
const Errors = require('../lib/errors.js')
var format = require('date-format');
let {
    User, Post, ProfilePicture, StaffApplications, AdminToken, PassKey, Thread, Category, Sequelize, Ip, Ban, sequelize
} = require('../models')
let pagination = require('../lib/pagination.js')
const sgMail = require('@sendgrid/mail');
const MailGen = require('mailgen')
const crypto = require("crypto")
const cryptoRandomString = require("crypto-random-string")
const rateLimit = require("express-rate-limit");

const emailLimiter = rateLimit({
    windowMs: 60000,
    max: 1, // limit each IP to 100 requests per windowMs
    message: "{\"errors\":[{\"name\":\"rateLimit\",\"message\":\"You may only make 1 request to this endpoint per minute.\",\"status\":429}]}"
});

function setUserSession(req, res, username, UserId, admin) {
    req.session.loggedIn = true
    req.session.username = username
    req.session.UserId = UserId
    res.cookie('username', username)

    if(admin) { req.session.admin = true }
}
router.post('/email-send', emailLimiter, async (req, res, next) => {
    const mailGenerator = new MailGen({
        theme: 'salted',
        product: {
            name: 'Kaverti',
            link: 'https://kaverti.com'
        },
    })
    let queryObj = {
        attributes: {include: ['email', 'emailVerified', 'emailToken', 'username']},
        where: {username: req.session.username}
    }
    let user = await User.findOne(queryObj)
    await user.rand()
    const verifyEmail = {
        body: {
            name: user.username,
            intro: 'Welcome to Kaverti',
            action: {
                instructions: 'Please verify your account via the button below',
                button: {
                    color: '#33b5e5',
                    text: 'Verify account',
                    link: 'https://kaverti.com/verify/?token=' + user.emailToken,
                },
            },
        },
    }
    const emailTemplate = mailGenerator.generate(verifyEmail)
    const message = {
        to: user.email,
        from: 'automailer@kaverti.com',
        subject: 'Kaverti account verification',
        html: emailTemplate
    }

    const sendMail = async () => {
        try {
            sgMail.setApiKey("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")
            return sgMail.send(message)
        } catch (error) {
            throw new Error(error.message)
        }
    }
    try {
        if(user.emailVerified) {
            throw Errors.alreadyVerified
        } else {
            const sent = await sendMail()
            if (sent) {
                res.send({ message: 'Email has been sent, check your spam if you can\'t find it!' })
            }
        }
    } catch (error) {
        throw new Error(error.message)
    }
});
router.get('/email-verify/:token', async (req, res) => {
    try {
        let queryObj = {
            attributes: {include: ['emailToken', 'emailVerified']},
            where: { username: req.session.username }
        }
        let user = await User.findOne(queryObj)
        if (user.emailToken == req.params.token) {
            user.emailVerify()
            res.status(200)
            res.json({
                success: "true"
            })
        } else {
            res.status(400)
            res.json({
                errors: [Errors.invalidParameter('token', 'Invalid token')]
            })
        }
    } catch (e) {
        res.status(400)
        res.json({
            errors: [Errors.invalidParameter('token', 'Invalid token')]
        })
    }
});
router.post('/oidfhuisadhi8243', async (req, res) => {
    try {
        await Ban.isIpBanned(req.ip)

        let userParams = {
            username: req.body.username,
            email: req.body.email,
            hash: req.body.password,
            passkey: req.body.passkey,
            admin: false,
            bodyColor: '#fffff',
            headColor: '#fffff',
            leftLegColor: '#fffff',
            rightLegColor: '#fffff',
            leftArmColor: '#fffff',
            rightArmColor: '#fffff',
            koins: '250',
            currency2: '0',
            picture: 'default',
            booster: false,
            emailToken: crypto(16)
        }
        let user = await User.create(userParams)
        await Ip.createIfNotExists(req.ip, user)

        setUserSession(req, res, user.username, user.id, userParams.admin)
        res.json(user.toJSON())
    } catch (e) { next(e) }
})
router.post('/', async (req, res, next) => {
    try {
        await Ban.isIpBanned(req.ip)

        let userParams = {
            username: req.body.username,
            email: req.body.email,
            hash: req.body.password,
            passkey: req.body.passkey,
            admin: false,
            bodyColor: '#fffff',
            headColor: '#fffff',
            leftLegColor: '#fffff',
            rightLegColor: '#fffff',
            leftArmColor: '#fffff',
            rightArmColor: '#fffff',
            koins: '250',
            currency2: '0',
            picture: 'default',
            developerMode: false,
            booster: false,
            emailToken: crypto(16)
        }
        throw Error.registrationsDisabled
        let user = await User.create(userParams)
        await Ip.createIfNotExists(req.ip, user)

        setUserSession(req, res, user.username, user.id, userParams.admin)
        res.json(user.toJSON())
    } catch (e) { next(e) }
})
router.post('/job-application', async (req, res, next) => {
    try {
        let userParams = {
            username: req.body.username,
            dob: req.body.dob,
            email: req.body.email,
            whyWork: req.body.whyWork,
            otherForm: req.body.otherForm,
            experience: req.body.experience,
            selectedOption: req.body.selectedOption,
        }
        await StaffApplications.submitApplication(userParams)
    } catch (e) { next(e) }
})
router.get('/:username', async (req, res, next) => {
    try {
        let queryObj = {
            attributes: {exclude: ['hash', 'email', 'emailVerified', 'koins', 'currency2', 'emailToken', 'passwordResetExpiry', 'passwordResetToken', 'experimentMode', 'developerMode']},
            where: {username: req.params.username}
        }

        if(req.query.posts) {

            let { from, limit } = pagination.getPaginationProps(req.query, true)

            let postInclude = {
                model: Post,
                include: Post.includeOptions(),
                limit,
                order: [['id', 'DESC']]
            }
            if(from !== null) {
                postInclude.where = { id: { $lte: from } }
            }
            queryObj.include = [postInclude]

            let user = await User.findOne(queryObj)
            if(!user) throw Errors.accountDoesNotExist

            let meta = await user.getMeta(limit)

            res.json(Object.assign( user.toJSON(limit), { meta } ))
        } else if(req.query.threads) {
            let queryString = ''

            Object.keys(req.query).forEach(query => {
                queryString += `&${query}=${req.query[query]}`
            })

            res.redirect('/api/v1/forums/category/ALL?username=' + req.params.username + queryString)
        } else {
            let user = await User.findOne(queryObj)
            if(!user) throw Errors.accountDoesNotExist

            res.json(user.toJSON())
        }


    } catch (err) { next(err) }
})

router.post('/login', async (req, res, next) => {
    try {
        await Ban.isIpBanned(req.ip, req.body.email)

        let user = await User.findOne({ where: {
                username: req.body.username
            }})
        if(user) {
            if(await user.comparePassword(req.body.password)) {
                await Ip.createIfNotExists(req.ip, user)

                setUserSession(req, res, user.username, user.id, user.admin)
                res.json({
                    username: user.username,
                    admin: user.admin,
                    success: true
                })
            } else {
                res.status(401)
                res.json({
                    errors: [Errors.invalidLoginCredentials]
                })
            }
        } else {
            res.status(401)
            res.json({
                errors: [Errors.invalidLoginCredentials]
            })
        }
    } catch (err) { next(err) }
})

router.all('*', (req, res, next) => {
    if(req.session.username) {
        next()
    } else {
        res.status(401)
        res.json({
            errors: [Errors.requestNotAuthorized]
        })
    }
})

router.put('/delete', async (req, res, next) => {
    try {
        if(req.session.username == "undefined") {
            throw Errors.requestNotAuthorized
        }
        if(req.session.username == "null") {
            throw Errors.requestNotAuthorized
        }
        if(req.session.username == "") {
            throw Errors.requestNotAuthorized
        }

        let user = await User.findOne({ where: {
                username: req.session.username
            }})
        await user.destroyVerifyPassword(req.body.password)

        req.session.destroy(() => {
            res.clearCookie('username')
            res.clearCookie('admin')
            res.json({ success: true })
        })

    } catch (e) { next(e) }
})

router.get('/', async function(req, res) {
    try {
        let sortFields = {
            createdAt: 'X.id',
            username: 'X.username',
            threadCount: 'threadCount',
            postCount: 'postCount',
            description: 'description'
        };
        let offset = Number.isInteger(+req.query.offset) ? +req.query.offset : 0;
        let havingClause = '';

        if (req.query.role === 'admin') {
            havingClause = 'HAVING Users.admin = true';
        } else if (req.query.role === 'user') {
            havingClause = 'HAVING Users.admin = false';
        } else {
            havingClause = '';
        }

        if (req.query.search) {
            //I.e. if there is not already a HAVING clause
            if (!havingClause.length) {
                havingClause = 'HAVING ';
            } else {
                havingClause += ' AND ';
            }

            havingClause += 'Users.username LIKE $search';
        }

        let sql = `
			SELECT X.username, X.admin, X.bot, X.booster, X.description, X.koins, X.bodyColor, X.headColor, X.leftLegColor, X.rightLegColor, X.leftArmColor, X.rightArmColor, X.hidden, X.system, X.createdAt, X.postCount, COUNT(Threads.id) as threadCount
			FROM (
				SELECT Users.*, COUNT(Posts.id) as postCount
				FROM Users
				LEFT OUTER JOIN Posts
				ON Users.id = Posts.UserId
				GROUP BY Users.id
				${havingClause}
			) as X
			LEFT OUTER JOIN Threads
			ON X.id = Threads.UserId
			GROUP BY X.id
			ORDER BY ${sortFields[req.query.sort] || 'X.id'}
			LIMIT 200
            OFFSET ${offset}
		`;

        let users = await sequelize.query(sql, {
            model: User,
            attributes: {exclude: ['hash', 'email', 'emailVerified', 'koins', 'currency2', 'emailToken', 'passwordResetExpiry', 'passwordResetToken', 'experimentMode', 'developerMode']},
            bind: {search: req.query.search + '%'}
        });

        res.json(users)
    } catch (e) {
    }
})

module.exports = router;
